// Generated by CoffeeScript 1.9.1
(function() {
  var Router, _lazylayout, decode, indexof, init, query, ref, replaceplus, router, startswith,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  ref = require('./fun'), startswith = ref.startswith, indexof = ref.indexof;

  _lazylayout = require('./view')._lazylayout;

  replaceplus = function(s) {
    return s.replace(/\+/g, ' ');
  };

  decode = function(s) {
    return decodeURIComponent(replaceplus(s));
  };

  query = function(s, ret) {
    var arr, dkey, dval, key, m, prev, ref1, val;
    if (ret == null) {
      ret = {};
    }
    if (!s) {
      return ret;
    } else if (s[0] === '&') {
      return query(s.slice(1), ret);
    } else {
      ref1 = s.match(/([^&=]+)=?([^&]*)/) || [''], m = ref1[0], key = ref1[1], val = ref1[2];
      if (key) {
        dkey = decode(key);
        dval = decode(val);
        if ((prev = ret[dkey]) != null) {
          arr = Array.isArray(prev) ? prev : ret[dkey] = [prev];
          arr.push(decode(val));
        } else {
          ret[dkey] = dval;
        }
      }
      return query(s.substring(m.length + 1), ret);
    }
  };

  Router = (function() {
    Router.prototype.loc = null;

    Router.prototype._route = function() {};

    Router.prototype._path = null;

    Router.prototype._exec = null;

    function Router(win) {
      this.win = win;
      this.exec = bind(this.exec, this);
      this.path = bind(this.path, this);
      this.route = bind(this.route, this);
      this._lazynavigate = bind(this._lazynavigate, this);
      this.navigate = bind(this.navigate, this);
      this._check = bind(this._check, this);
      this._consume = bind(this._consume, this);
      this.win.addEventListener('onpopstate', this._check, false);
      this.loc = {};
    }

    Router.prototype._consume = function(loc, pos, query, fun) {
      var sexec, spath, sub;
      sub = loc.substring(pos);
      spath = this._path;
      sexec = this._exec;
      this._exec = (function(_this) {
        return function(f) {
          return f(sub, query);
        };
      })(this);
      this._path = (function(_this) {
        return function(p, f) {
          if (startswith(sub, p)) {
            return _this._consume(loc, pos + p.length, query, f);
          }
        };
      })(this);
      try {
        fun();
      } finally {
        this._path = spath;
        this._exec = sexec;
      }
      return true;
    };

    Router.prototype._check = function() {
      var pathname, ref1, search;
      ref1 = this.win.location, pathname = ref1.pathname, search = ref1.search;
      if (this.loc.pathname === pathname && this.loc.search === search) {
        return false;
      }
      return this._run(pathname, search);
    };

    Router.prototype._run = function(pathname, search) {
      var q;
      if (pathname == null) {
        pathname = '/';
      }
      if (search == null) {
        search = '';
      }
      this._setLoc(pathname, search);
      q = query(search[0] === '?' ? search.slice(1) : search);
      try {
        this._lazynavigate(true);
        _lazylayout(true);
        return this._consume(pathname, 0, q, this._route);
      } finally {
        this._lazynavigate(false);
        _lazylayout(false);
      }
    };

    Router.prototype._setLoc = function(pathname, search) {
      if (pathname == null) {
        pathname = '/';
      }
      if (search == null) {
        search = '';
      }
      this.loc.pathname = pathname;
      return this.loc.search = search;
    };

    Router.prototype.navigate = function(url, trigger) {
      var pathname, ref1, search;
      if (trigger == null) {
        trigger = true;
      }
      if (this._lazynav) {
        if (url) {
          this._lazynav = [url, trigger];
        }
      } else {
        this.win.history.pushState({}, '', url);
        if (trigger) {
          this._check();
        } else {
          ref1 = this.win.location, pathname = ref1.pathname, search = ref1.search;
          this._setLoc(pathname, search);
        }
      }
      return void 0;
    };

    Router.prototype._lazynavigate = function(suspend) {
      var args;
      if (suspend) {
        return this._lazynav = '__NOT';
      } else {
        args = this._lazynav;
        delete this._lazynav;
        if (args !== '__NOT') {
          return this.navigate.apply(this, args);
        }
      }
    };

    Router.prototype.route = function(f) {
      this._route = f;
      this.loc = {};
      router._check();
      return void 0;
    };

    Router.prototype.path = function(p, f) {
      return typeof this._path === "function" ? this._path(p, f) : void 0;
    };

    Router.prototype.exec = function(f) {
      return typeof this._exec === "function" ? this._exec(f) : void 0;
    };

    return Router;

  })();

  router = null;

  (init = function() {
    return router = new Router(window);
  })();

  module.exports = {
    route: router.route,
    path: router.path,
    exec: router.exec,
    navigate: router.navigate,
    _lazynavigate: router._lazynavigate
  };

  if (typeof global !== "undefined" && global !== null ? global.__TEST_ROUTER : void 0) {
    module.exports.query = query;
    module.exports.router = router;
    module.exports.reinit = init;
  }

}).call(this);
